﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using C1.C1Preview;
using C1.Win.C1Preview;
using System.Drawing.Printing;

namespace C1PrintDocument_NewPage
{
    public partial class Form1 : Form
    {
        C1PrintPreviewControl c1PrintPreviewControl1 = new C1PrintPreviewControl();   
        public Form1()
        {
            InitializeComponent();
        }


        private void Form1_Load(object sender, EventArgs e)
        {
           
            #region StartDoc-EndDoc
            printDoc.AllowNonReflowableDocs = true;
            printDoc.StartDoc();
            printDoc.PageLayout.PageSettings.PaperKind = System.Drawing.Printing.PaperKind.A4;

            var AdditionalHeader = new RenderArea(printDoc);
            AdditionalHeader.Stacking = StackingRulesEnum.BlockTopToBottom;

            var TitleBlock = new RenderText(printDoc);
            TitleBlock.Text = "Some Text here";
            AdditionalHeader.Children.Add(TitleBlock);

            var ParametersBlock = new RenderText(printDoc);
            ParametersBlock.Text = "Some more Text here";
            AdditionalHeader.Children.Add(ParametersBlock);
            //RenderArea.HeaderVert = AdditionalHeader;

            var RenderTable = new C1.C1Preview.RenderTable(printDoc);
            //RenderTable.Width = 200; // Calculated Value
            RenderTable.SplitHorzBehavior = SplitBehaviorEnum.SplitIfNeeded;
            printDoc.Body.Children.Add(RenderTable);

            printDoc.DefaultUnit = C1.C1Preview.UnitTypeEnum.Mm;

            printDoc.PageLayout.PageSettings.Landscape = false;
            printDoc.PageLayout.PageSettings.PaperKind = PaperKind.A4;

            for (int row = 0; row < 400; ++row)
            {
                for (int col = 0; col < 5; ++col)
                {
                    RenderTable.Cells[row, col].Text = string.Format("Cell ({0},{1})", row, col);
                    var renderTextObject = RenderTable.Cells[row, col].RenderObject as RenderText;
                    if (renderTextObject != null)
                    {
                        renderTextObject.Style.WordWrap = false;
                        renderTextObject.Clip = true;
                    }
                }

                if (row % 2 == 0 && row != 0)
                {
                    RenderTable.Rows[row].Style.Brush = Brushes.Aqua;
                }
            }

            for (int i = 0; i < RenderTable.Cols.Count - 1; i++)
            {
                RenderTable.Cols[i].Width = "20";
            }
            RenderTable.Rows.Insert(0, 2);
            RenderTable.RowGroups[0, 3].Header = C1.C1Preview.TableHeaderEnum.Page;
            RenderTable.RowGroups[0, 3].Style.Brush = Brushes.DarkGray;

            RenderTable.Cells[0, 0].Text = "Some Text here";
            RenderTable.Cells[1, 0].Text = "Some Text here";
            RenderTable.Cells[0, 0].SpanCols = RenderTable.Cols.Count;
            RenderTable.Cells[1, 0].SpanCols = RenderTable.Cols.Count;
            RenderTable.Cells[0, 0].CellStyle.BackColor = Color.Yellow;
            RenderTable.Cells[1, 0].CellStyle.BackColor = Color.Turquoise;

            printDoc.EndDoc();
            c1PrintPreviewControl1.Document = printDoc;
            c1PrintPreviewControl1.Dock = DockStyle.Fill;   
            this.Controls.Add(c1PrintPreviewControl1);

            printDoc.Export("../../ExportResult.pdf"); 
            #endregion

        }

    }
}
